﻿Imports Infragistics.Shared
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinChart
Imports Infragistics.Win.UltraWinListView
Imports Infragistics.UltraChart.Core.Primitives
Imports Infragistics.UltraChart.Core
Imports Infragistics.UltraChart.Core.Layers
Imports Infragistics.UltraChart.Data
Imports Infragistics.UltraChart.Core.Util
Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Shared.Styles

Public Class Form1
  Public Enum ColumnKey As Short
    Type
    X
    Y
    W
    H
    GanttSeries
    GanttItem
  End Enum
  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    UltraListView1.ViewSettingsDetails.ImageSize = Size.Empty
    UltraChart1.Axis.X.RangeMin = CDate("6 April 2010 9:00 am").Ticks
    UltraChart1.Axis.X.RangeMax = CDate("6 April 2010 9:00 am").AddHours(6).Ticks
  End Sub
  Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
    Me.Close()
    End
  End Sub
  Private Sub btnFill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFill.Click
    Try
      UltraChart1.Series.Clear()
      Dim initDate As DateTime = CDate("6 April 2010 9:00 am")
      For i As Integer = 1 To CInt(nudNumSeries.Value)
        Dim ganttSeries As GanttSeries = New GanttSeries(String.Format("{0}", i))
        For j As Integer = 1 To CInt(nudItemsPerSeries.Value)
          Dim ganttItem As GanttItem = ganttSeries.Items.Add(New GanttItem(String.Format("{0}.{1}", i, j)))
          Dim dummyTimeEntry As GanttTimeEntry = New GanttTimeEntry(Now.AddYears(-100), Now.AddYears(-100).AddHours(1), 0, -1, String.Format("{0}.{1}", i, j), 100)
          ganttItem.Times.Add(dummyTimeEntry)
          Dim fromDate As DateTime = initDate.AddHours(i + j)
          Dim toDate As DateTime = fromDate
          For k As Integer = 1 To CInt(nudTimesPerItem.Value)
            toDate = fromDate.AddHours(k)
            Dim sid As String = String.Concat(i.ToString("000"), j.ToString("000"), k.ToString("000"))
            Dim iid As Integer = Integer.Parse(sid)
            Dim timeEntry As GanttTimeEntry = New GanttTimeEntry(fromDate, toDate, iid, -1, String.Format("{0}.{1}", i, j), 100)
            'Dim timeEntry As GanttTimeEntry = New GanttTimeEntry(fromDate, toDate, Integer.Parse(String.Concat(i.ToString("000"), j.ToString("000"), k.ToString("000"))), -1, String.Format("{0}.{1}", i, j), 100)
            ganttItem.Times.Add(timeEntry)
            fromDate = toDate.AddHours(1)
          Next
        Next
        UltraChart1.Series.Add(ganttSeries)
      Next
    Catch ex As Exception
      Debug.Print(String.Format("{0}.Fill Error{1}{2}", Me.GetType.Name, vbCrLf, ex.Message))
    End Try
  End Sub

  Private Sub btnZoomLeftIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomLeftIn.Click
    UltraChart1.Axis.X.RangeMin = (New Date(CLng(UltraChart1.Axis.X.RangeMin))).AddHours(1).Ticks
  End Sub
  Private Sub btnZoomLeftOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomLeftOut.Click
    UltraChart1.Axis.X.RangeMin = (New Date(CLng(UltraChart1.Axis.X.RangeMin))).AddHours(-1).Ticks
  End Sub
  Private Sub btnZoomRightOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomRightOut.Click
    UltraChart1.Axis.X.RangeMax = (New Date(CLng(UltraChart1.Axis.X.RangeMax))).AddHours(1).Ticks
  End Sub
  Private Sub btnZoomRightIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomRightIn.Click
    UltraChart1.Axis.X.RangeMax = (New Date(CLng(UltraChart1.Axis.X.RangeMax))).AddHours(-1).Ticks
  End Sub

  Private Sub UltraScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles UltraScrollBar1.Scroll
    If UltraScrollBar1.Minimum <= e.NewValue And e.NewValue <= UltraScrollBar1.Maximum Then
      Dim startDateBefore As DateTime = (New Date(CLng(UltraChart1.Axis.X.RangeMin)))
      Dim endDateBefore As DateTime = (New Date(CLng(UltraChart1.Axis.X.RangeMax)))
      Dim spanTicks As Double = UltraChart1.Axis.X.RangeMax - UltraChart1.Axis.X.RangeMin

      Select Case e.Type
        Case ScrollEventType.LargeDecrement : startDateBefore = startDateBefore.AddDays(CShort(e.NewValue - e.OldValue))
        Case ScrollEventType.LargeIncrement : startDateBefore = startDateBefore.AddDays(CShort(e.NewValue - e.OldValue))
        Case ScrollEventType.SmallDecrement : startDateBefore = startDateBefore.AddHours(CShort(e.NewValue - e.OldValue))
        Case ScrollEventType.SmallIncrement : startDateBefore = startDateBefore.AddHours(CShort(e.NewValue - e.OldValue))
        Case ScrollEventType.ThumbTrack : startDateBefore = startDateBefore.AddHours(CShort(e.NewValue - e.OldValue))
      End Select

      If e.Type = ScrollEventType.LargeIncrement AndAlso UltraScrollBar1.Maximum <= e.NewValue + UltraScrollBar1.LargeChange Then
        UltraScrollBar1.Value = UltraScrollBar1.Maximum - UltraScrollBar1.LargeChange
      End If
      If e.Type <> ScrollEventType.ThumbTrack Then
        If e.NewValue = UltraScrollBar1.Minimum Then
          UltraScrollBar1.Minimum -= CInt(UltraScrollBar1.LargeChange / 2)
          UltraScrollBar1.Maximum -= CInt(UltraScrollBar1.LargeChange / 2)
        Else
          UltraChart1.Axis.X.RangeMin = startDateBefore.Ticks
          UltraChart1.Axis.X.RangeMax = startDateBefore.Ticks + spanTicks
        End If
        If e.NewValue + UltraScrollBar1.LargeChange >= UltraScrollBar1.Maximum Then
          UltraScrollBar1.Minimum += CInt(UltraScrollBar1.LargeChange / 2)
          UltraScrollBar1.Maximum += CInt(UltraScrollBar1.LargeChange / 2)
        End If
      End If
    End If
  End Sub

  Private Sub UltraChart1_FillSceneGraph(ByVal sender As Object, ByVal e As Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs) Handles UltraChart1.FillSceneGraph
    If Not Me.IsHandleCreated Then Exit Sub
    Dim i As Integer = 0
    UltraListView1.Items.Clear()
    For Each o As Primitive In e.SceneGraph
      If o IsNot Nothing Then
        If TypeOf o Is Box Then
          Dim newItem As New UltraListViewItem(i.ToString)
          newItem.Value = i
          UltraListView1.Items.Add(newItem)
          newItem.SubItems.Item(ColumnKey.Type.ToString).Value = o.GetType.Name
          If o.Series IsNot Nothing Then
            newItem.SubItems.Item(ColumnKey.GanttSeries.ToString).Value = o.Series.Key
          End If
          If o.DataPoint IsNot Nothing AndAlso TypeOf o.DataPoint Is GanttItem Then
            newItem.SubItems.Item(ColumnKey.GanttItem.ToString).Value = CType(o.DataPoint, GanttItem).Key
          End If
          Dim bx As Box = CType(o, Box)
          newItem.SubItems.Item(ColumnKey.X.ToString).Value = bx.rect.X
          newItem.SubItems.Item(ColumnKey.Y.ToString).Value = bx.rect.Y
          newItem.SubItems.Item(ColumnKey.W.ToString).Value = bx.rect.Width
          newItem.SubItems.Item(ColumnKey.H.ToString).Value = bx.rect.Height
        End If
      End If
      i += 1
    Next
  End Sub
End Class
